# Detect the distribution in use
%global __despace head -n 1 | tr -d '[:space:]' | sed -e 's/[(].*[)]//g'
%global __lower4 cut -c 1-4 | tr '[:upper:]' '[:lower:]'
%global __distfile %([ -f /etc/SuSE-release ] && echo /etc/SuSE-release || echo /etc/redhat-release)
%global __distinit %(sed -e 's/ release .*//' -e 's/\\([A-Za-z]\\)[^ ]*/\\1/g' %{__distfile} | %{__despace} | %{__lower4})
%global __distvers %(sed -e 's/.* release \\([^. ]*\\).*/\\1/' %{__distfile} | %{__despace})
# Identify CentOS Linux and Scientific Linux as rhel
%if "%{__distinit}" == "c" || "%{__distinit}" == "cl" || "%{__distinit}" == "sl" || "%{__distinit}" == "sls"
%global __distinit rhel
%endif
# Dist tag for Fedora is still "fc"
%if "%{__distinit}" == "f"
%global __distinit fc
%endif

# perl_vendorlib/perl_vendorarch not defined by default prior to F-2
%{!?perl_vendorlib: %global perl_vendorlib %(eval "`perl -V:installvendorlib`"; echo $installvendorlib)}

Summary:	Search mailboxes for a particular email
Name:		grepmail
Version:	5.3034
Release:	4.0.cf.%{__distinit}%{__distvers}
License:	GPL+
Group:		Applications/Text
Url:		http://search.cpan.org/dist/grepmail/
Source0:	http://search.cpan.org/CPAN/authors/id/D/DC/DCOPPIT/grepmail-%{version}.tar.gz
Source1:	http://cpansearch.perl.org/src/ADAMK/Module-Install-0.91/lib/Module/AutoInstall.pm
Patch0:		grepmail-5.3034-revert-recursive-test-change.patch
Patch1:		grepmail-5.3034-empty-file-not-error.patch
Patch2:		grepmail-5.3034-date-manip-6.patch
BuildRoot:	%{_tmppath}/%{name}-%{version}-%{release}-root-%(id -nu)
BuildArch:	noarch
BuildRequires:	perl(Date::Manip)
BuildRequires:	perl(Date::Parse)
BuildRequires:	perl(Digest::MD5)
BuildRequires:	perl(ExtUtils::MakeMaker)
BuildRequires:	perl(Mail::Mbox::MessageParser) >= 1.4001
BuildRequires:	perl(Test::More)
Requires:	perl(:MODULE_COMPAT_%(eval "`perl -V:version`"; echo $version))
Requires:	perl(Mail::Mbox::MessageParser) >= 1.4001
# The following module requirements are optional and hence not picked up by RPM automatically.
# Adding manual deps for them improves grepmail's functionality.
Requires:	perl(Date::Manip)
Requires:	perl(Date::Parse)
Requires:	perl(Digest::MD5)
# perl(Date::Parse) can be found in the perl-TimeDate package

%description
Grepmail searches a normal or compressed mailbox for a given regular
expression, and returns those emails that match it. Piped input is allowed,
and date and size restrictions are supported, as are searches using logical
operators.

%prep
%setup -q -n %{name}-%{version}

# Module::AutoInstall should be shipped with distribution
# http://code.google.com/p/grepmail/issues/detail?id=1
cp -p %{SOURCE1} inc/Module/

# Revert recursive test change in 5.3034 that breaks test suite
# http://code.google.com/p/grepmail/issues/detail?id=2
%patch0 -p1

# Empty files are not treated as errors by Mail::Mbox::MessageParser >= 1.5002
# http://code.google.com/p/grepmail/issues/detail?id=2
%patch1 -p1

# Fix incompatibilities with Date::Manip 6.x
# http://rt.cpan.org/Public/Bug/Display.html?id=54621
%patch2 -p1

%build
perl Makefile.PL INSTALLDIRS=vendor --default
make %{?_smp_mflags}

%install
rm -rf %{buildroot}
make pure_install PERL_INSTALL_ROOT=%{buildroot}
find %{buildroot} -type f -name .packlist -exec rm -f {} ';'
find %{buildroot} -depth -type d -exec rmdir {} ';' 2>/dev/null
chmod -R u+w %{buildroot}

%check
export LANG=C
export TZ=GMT0
make test

%clean
rm -rf %{buildroot}

%files
%defattr(-,root,root,-)
%doc README* CHANGES LICENSE TODO
%{_bindir}/grepmail
%{_mandir}/man1/grepmail.1*

%changelog
* Fri Oct  7 2011 Paul Howarth <paul@city-fan.org> 5.3034-4.0.cf
- BR/R: perl(Digest::MD5) for improved memory usage
- Nobody else likes macros for commands
- Fix dist tag for CentOS 6 and Scientific Linux

* Fri Jun 25 2010 Paul Howarth <paul@city-fan.org> 5.3034-3.1.cf
- Rebuild for perl 5.12.1 in Rawhide

* Thu May 27 2010 Paul Howarth <paul@city-fan.org> 5.3034-3.0.cf
- Fix dist tag for RHEL-6 Beta

* Mon Feb 15 2010 Paul Howarth <paul@city-fan.org> 5.3034-2.0.cf
- Fix incompatibilities with Date::Manip 6.x (#564839, CPAN RT#54621)

* Tue Sep  1 2009 Paul Howarth <paul@city-fan.org> 5.3034-1.0.cf
- Update to 5.3034
  - fix man page year typo (Debian bug #428973)
  - updated to the latest version of Module::Install
  - added TODO to the distribution
  - fix a bug where grepmail could abort with -L
  - fix a bug in the -R test that could cause a false test failure
  - fix uninitialized variable warnings for emails missing certain headers
- URLs moved back to search.cpan.org
- Buildreq perl(Test::More)
- Add AutoInstall.pm from Module::Install 0.91, needed by Makefile.PL
- Revert change to t/recursive.t from 5.3033 that causes test failure
- Patch t/nonexistent_mailbox.t to support changed behaviour of
  Mail::Mbox::MessageParser >= 1.5002

* Wed Apr 18 2007 Paul Howarth <paul@city-fan.org> 5.3033-4.0.cf
- Buildrequire perl(ExtUtils::MakeMaker) instead of perl-devel
- Update to SLES-compatible dist tag macros
- Clarify license as GPL (any version)

* Wed Mar  7 2007 Paul Howarth <paul@city-fan.org> 5.3033-2
- Buildreq perl-devel for Fedora 7 onwards
- Include LICENSE file

* Fri Mar  2 2007 Paul Howarth <paul@city-fan.org> 5.3033-1
- Update to 5.3033
- CPAN RT#24341 fixed upstream, remove patch
- Permissions fixes in %%prep no longer needed
- Changed download host from dl.sf.net to downloads.sf.net

* Tue Feb 27 2007 Paul Howarth <paul@city-fan.org> 5.3032-3
- Add patch to fix CPAN RT#24341 (test suite failures with recent
  Mail::Mbox::MessageParser)
- Fix argument order for find with -depth
- Fix dist tag for Fedora 7 onwards

* Thu Sep  7 2006 Paul Howarth <paul@city-fan.org> 5.3032-2
- Rewrite distribution-detection code to not do build-time rpmdb queries
- Remove %%__perl_version macro, used only once
- Define %%{__id_u} in a more portable way
- Don't use macros in command paths, hardcode them instead
- Remove buildroot unconditionally in %%clean and %%install
- Use --default option to Makefile.PL to avoid interactive prompting
- Use module name dependencies rather than package name dependencies
- Fix documentation permissions

* Thu Aug  4 2005 Paul Howarth <paul@city-fan.org> 5.3032-1
- Update to 5.3032
- Remove unused macro definitions
- Remove redundant compiler optimization flags, not needed for noarch package
- Update versioned dependency on perl-Mail-Mbox-MessageParser

* Tue Jun  7 2005 Paul Howarth <paul@city-fan.org> 5.3031-1
- Update to 5.3031

* Thu May 19 2005 Paul Howarth <paul@city-fan.org> 5.3030-2
- Rewrite spec file in (mainly) Fedora Extras style
- Include full URL for source
- Use MODULE_COMPAT dependency style and remove explicit perl dependency
- Remove MANIFEST from %%doc
- Run tests in "C" locale

* Wed Dec 22 2004 Paul Howarth <paul@city-fan.org> 5.3030-1
- Update to 5.3030
- Update perl-Mail-Mbox-MessageParser dependency to >= 1.2130

* Wed Sep 22 2004 Paul Howarth <paul@city-fan.org> 5.30.1-1
- Update to 5.30.1
- Hack Makefile.PL to remove references to Benchmark::Timer so that the RPM
  build doesn't need it at install time
- Add requirement for perl-DateManip
- Set TZ before running tests to that Date::Manip tests don't fall over due to
  unexpected timezone

* Sat Jul 31 2004 Paul Howarth <paul@city-fan.org> 5.30-1
- Update to 5.30
- Moved `make test' to %%check section
- General tidy-up of spec file
- Require perl-Mail-Mbox-MessageParser >= 1.20
- Require perl-TimeDate

* Thu Apr 15 2004 Paul Howarth <paul@city-fan.org> 5.23-3
- Added explicit perl dependency to ensure that an RPM built on a
  system with an updated version of perl (and hence having files
  installed in a place that a non-updated system won't find them)
  will not install on the non-updated system. In such cases, just
  rebuild from the source RPM.
- Changed distribution-identifying macros for greater portability.

* Mon Feb 16 2004 Paul Howarth <paul@city-fan.org> 5.23-2
- Unified Fedora and Red Hat spec file

* Tue Feb 10 2004 Paul Howarth <paul@city-fan.org> 5.23-1
- Update to 5.23
- Corrected License:

* Mon Nov 24 2003 Paul Howarth <paul@city-fan.org> 5.22-1
- Initial RPM build.
